;esercizio volta scorsa
(define-struct binding (name value))

(define l (list (make-binding 'a 1)
                (make-binding 'b 2)
                (make-binding 'a 3)))

;binding: nome + lista associativa -> la lista di tutti i
;valori associati al nome nella lista associativa
(define (bindings name l)
  (cond
    [(empty? l) empty]
    [(symbol=? (binding-name (first l)) name)
     (cons (binding-value (first l))
           (bindings name (rest l)))]
    [else (bindings name (rest l))]))

;un albero generalizzato (di numeri) e' una coppia
;<numero, lista di figli>
;la lista di figli puo' essere vuota ed ogni figlio e' a sua
;volta un albero generalizzato

(define-struct gentree (value children))
(define t (make-gentree 1
                        (list (make-gentree 2
                                            (list (make-gentree 7 empty)))
                              (make-gentree 5 empty)
                              (make-gentree 4
                                            (list (make-gentree 5 empty)
                                                  (make-gentree 6 empty))))))
;funzioni su alberi generalizzati:
; - trattamento uniforme dei nodi dell'albero
;  - funzioni il cui valore di ritorno non dipende dal valore
;    contenuto nei nodi

;funzione card: albero -> numero di nodi contenuti nell'albero
(define (card t)
  (+ 1 (card-children (gentree-children t))))
;card-children: lista di alberi -> numero di nodi contenuti in
;tutti gli alberi appartenenti alla lista
(define (card-children l)
  (cond
    [(empty? l) 0]
    [else (+ (card (first l)) (card-children (rest l)))]))

; - trattamento uniforme dei nodi dell'albero
;  - funzioni il cui valore di ritorno dipende dal valore
;    contenuto nei nodi

;visit: albero -> lista di tutti i nodi contenuti nell'albero
(define (visit t)
  (cons (gentree-value t)
        (visit-children (gentree-children t))))
;visit-children: lista di alberi -> lista di tutti i nodi
;contenuti negli alberi
(define (visit-children l)
  (cond
    [(empty? l) empty]
    [else
     (append (visit (first l)) (visit-children (rest l)))]))

;esercizio: definire la funzione postvisit
;postvisit: albero -> lista di tutti i nodi contenuti
;a differenza di visit (che implementa una previsita)
;postvisit deve implementare una postvisita, ovvero prima
;visita i figli e poi visita il nodo corrente

;sum: albero -> somma di tutti i valori contenuti nell'albero
(define (sum t)
  (+ (gentree-value t) (sum-children (gentree-children t))))
;sum-children: lista di alberi -> somma di tutti i valori
;contenuti negli alberi appartenenti alla lista
(define (sum-children l)
  (cond
    [(empty? l) 0]
    [else
     (+ (sum (first l))
          (sum-children (rest l)))]))

;esercizio pp (pretty printing)
;pp: albero -> stringa che rappresenta testualmente l'albero
;esempio: sull'albero t definito sopra, deve restituire la
;stringa "1(2(7())5()4(5()6()))"

;- funzioni che non trattano uniformemente i nodi dell'albero
; - funzioni che visitano completamente l'albero

;count: valore + albero -> numero di occorrenze del valore
;nell'albero
(define (count value t)
  (cond
    [(= (gentree-value t) value) ; ho trovato una occorrenza
     (+ 1 (count-children value (gentree-children t)))]
    [else (count-children value (gentree-children t))]))
;count-children: valore + lista di alberi -> numero di
;occorrenze del valore in tutti gli alberi della lista
(define (count-children value l)
  (cond
    [(empty? l) 0]
    [else
     (+ (count value (first l))
        (count-children value (rest l)))]))

;esercizio leaves
;leaves: albero -> lista delle foglie dell'albero

;- funzioni che non trattano uniformemente i nodi dell'albero
; - funzioni che non visita necessariamente tutto l'albero

;exists-odd: albero -> booleano, restituisce true se almeno uno
;dei valori contenuti nell'albero e' dispari, false altrimenti
(define (exists-odd t)
  (cond
    [(odd? (gentree-value t)) true]
    [else (exists-odd-children (gentree-children t))]))
(define (exists-odd-children l)
  (cond
    [(empty? l) false]
    [(exists-odd (first l)) true]
    [else (exists-odd-children (rest l))]))

;versione di exists-odd che utilizza la corto circuitazione
;degli operatori logici scheme
(define (exists-odd2 t)
  (or (odd? (gentree-value t))
         (exists-odd-children2 (gentree-children t))))
(define (exists-odd-children2 l)
  (cond
    [(empty? l) false]
    [else (or (exists-odd2 (first l))
              (exists-odd-children2 (rest l)))]))
