(define-struct gentree (value children))
(define t (make-gentree 1
                        (list (make-gentree 2
                                            (list (make-gentree 7 empty)))
                              (make-gentree 5 empty)
                              (make-gentree 4
                                            (list (make-gentree 5 empty)
                                                  (make-gentree 6 empty))))))

; postvisit: albero -> lista di numeri
; dato un albero generalizzato restituisce la lista di tutti
; i valori numerici contenuti in post-ordine
(define (postvisit t)
  (append
   (postvisit-children (gentree-children t))
   (list (gentree-value t))))

; postvisit-children: lista di alberi -> lista di numeri
(define (postvisit-children l)
  (cond
    [(empty? l) empty]
    [else (append (postvisit (first l))
                  (postvisit-children (rest l)))]))

; pp: albero -> stringa
; dato un albero restituisce una rappresentazione in formato
; stringa di tale albero
(define (pp t)
  (string-append (number->string (gentree-value t))
                 "("
                 (pp-children (gentree-children t))))
; pp-children: lista di alberi -> stringa
(define (pp-children l)
  (cond
    [(empty? l) ")"]
    [else
     (string-append
      (pp (first l))
      (pp-children (rest l)))]))

;esercizio: BFS - breadth first search, visita in ampiezza
;considerate un albero binario (def. vista a lezione)
;(define-struct nodo (value sx dx))
;dato un tale albero binario, la visita deve procedere a
;"piani", ovvero prima visita tutti i nodi a profondita' 0
;(la radice), poi visita tutti i nodi a profondita' 1 (i 2
;figli della radice), poi a profondita' 2 e cosi' via
;consiglio: vi serve una coda

;insert: numero + lista ordinata di numeri -> lista ordinata di
;numeri
;inserisce il numero nella lista ordinata in modo da
;rispettare l'ordinamento


;sort: lista di numeri -> lista ordinati di numeri
(define (sort l)
  (local ((define (insert n l)
            (cond
              [(empty? l) (list n)]
              [else
               (local ((define fst (first l)))
                 (cond
                   [(< n fst) (cons n l)]
                   [else (cons fst (insert n (rest l)))]))])))
    (cond
      [(empty? l) empty]
      [else (insert (first l) (sort (rest l)))])))
(define (insert l)
  (error 'a "pippo"))
(define somma
  (local ((define a 1)
          (define b 2)
          (define c 3))
    (+ a b c)))

;elezioni
;testo dell'esercizio disponibile qui:
;http://www.ccs.neu.edu/home/matthias/HtDP/Extended/elections.html

