
;hello: arg inutile (dummy) -> finestra
;la finestra conterra' un widget di testo all'interno del quale
;e' scritta la stringa "Hello, world!"
(define (hello dummy)
  (local ((define msg (make-message "Hello, world!")))
    (create-window (list (list msg)))))

;hello2: string -> finestra
(define (hello2 testo)
  (local ((define msg (make-message testo)))
    (create-window (list (list msg)))))
;esempio: (hello2 "Hello, world!")

;hello3: string -> finestra
(define (hello3 testo)
  (local ((define msg (make-message ""))
          (define (hello-callback e)
            ; scrive in msg la stringa testo
            (draw-message msg testo))
          (define hello-button
            (make-button "hello" hello-callback)))
    (create-window (list (list msg hello-button)))))
;esempio: (hello3 "Hello, world!")

;hello4: string -> finestra
(define (hello4 testo)
  (local ((define msg (make-message ""))
          (define (hello-callback e) (draw-message msg testo))
          (define (clear-callback e) (draw-message msg ""))
          (define hello-button
            (make-button "hello" hello-callback))
          (define clear-button
            (make-button "clear" clear-callback)))
    (create-window (list
                    (list hello-button msg clear-button)))))
;esempio: (hello4 "Hello, world!")

;copy: arg inutile
(define (copy dummy)
  (local ((define msg (make-message ""))
          (define input (make-text "input:"))
          (define (copy-callback e)
            (draw-message msg (text-contents input)))
          (define copy-button
            (make-button "copy" copy-callback)))
    (create-window
     (list
      (list input copy-button)
      (list msg)))))
;esempio: (copy empty)

;vote: lista di stringhe -> finestra
(define (vote choices)
  (local ((define choice (make-choice choices))
          (define msg (make-message ""))
          (define (vote-callback e)
            ;stampare la scelta corrente in msg
            (draw-message
             msg
             (list-ref choices (choice-index choice))))
          (define vote-button
            (make-button "vote" vote-callback)))
    (create-window (list (list choice vote-button)
                         (list msg)))))
;esempio: (vote (list "pizza" "sushi" "tigelle"))

;indirizzario email
;modello
;un contatto e' una coppia <nome, email> dove sia nome che
;email sono stringhe
(define-struct contact (name email))

;contactlist di esempio
(define contactlist
  (list (make-contact "zack" "zack@cs.unibo.it")
        (make-contact "nadia" "busi@cs.unibo.it")))

;lookup: lista di contact + stringa -> string o false
;data una lista di contatti ed un nome, restituisce l'email
;associata a quel nome nella lista di contatti (se esiste)
;altrimenti restituisce il boolean false
(define (lookup contactlist name)
  (cond
    [(empty? contactlist) false]
    [else
     (local ((define currcontact (first contactlist)))
       (cond
         [(string=? name (contact-name currcontact))
          (contact-email currcontact)]
         [else (lookup (rest contactlist) name)]))]))
;esempio: (lookup contactlist "zack")
;esempio: (lookup contactlist "zac")

;vista
;agenda: lista di contact -> finestra
(define (agenda contactlist)
  (local ((define msg (make-message ""))
          (define name (make-text "name:"))
          (define (lookup-callback e) ;controller
            (local
              ((define email
                (lookup contactlist (text-contents name))))
              (cond
                [(string? email) (draw-message msg email)]
                [else (draw-message msg "not found")])))
          (define lookup-button
            (make-button "lookup" lookup-callback)))
    (create-window (list (list name lookup-button)
                       (list msg)))))

